VariableScopeVisitor (groovy 2.4.3 API)
Date: 2015-03-23

Package: org.codehaus.groovy.classgen

## [Java] Class VariableScopeVisitor

- org.codehaus.groovy.classgen.VariableScopeVisitor

- goes through an AST and initializes the scopes

  Authors:
    Jochen Theodorou

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `def` | `VariableScopeVisitor(SourceUnit source, boolean recurseInnerClasses)`
    `def` | `VariableScopeVisitor(SourceUnit source)`
    `protected SourceUnit` | `getSourceUnit()`
    `void` | `prepareVisit(ClassNode node)` Setup the current class node context.
    `void` | `visitAnnotations(AnnotatedNode node)`
    `void` | `visitBinaryExpression(BinaryExpression be)`
    `void` | `visitBlockStatement(BlockStatement block)`
    `void` | `visitCatchStatement(CatchStatement statement)`
    `void` | `visitClass(ClassNode node)`
    `void` | `visitClosureExpression(ClosureExpression expression)`
    `void` | `visitConstructorCallExpression(ConstructorCallExpression call)`
    `protected void` | `visitConstructorOrMethod(MethodNode node, boolean isConstructor)`
    `void` | `visitDeclarationExpression(DeclarationExpression expression)`
    `void` | `visitField(FieldNode node)`
    `void` | `visitFieldExpression(FieldExpression expression)`
    `void` | `visitForLoop(ForStatement forLoop)`
    `void` | `visitIfElse(IfStatement ifElse)`
    `void` | `visitMethodCallExpression(MethodCallExpression call)`
    `void` | `visitProperty(PropertyNode node)`
    `void` | `visitPropertyExpression(PropertyExpression expression)`
    `void` | `visitVariableExpression(VariableExpression expression)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `visitMethod, visitField, visitProperty, visitConstructor, visitReturnStatement, visitDeclarationExpression, visitIfElse, visitClass, visitBreakStatement, visitContinueStatement, visitThrowStatement, visitSynchronizedStatement, visitCatchStatement, visitForLoop, visitBlockStatement, visitWhileLoop, visitDoWhileLoop, visitExpressionStatement, visitAssertStatement, visitTryCatchFinally, visitSwitch, visitCaseStatement, visitPackage, visitImports, visitAnnotations, visitClassExpression, visitPropertyExpression, visitConstantExpression, visitListExpression, visitMethodPointerExpression, visitVariableExpression, visitGStringExpression, visitArrayExpression, visitSpreadExpression, visitSpreadMapExpression, visitNotExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitCastExpression, visitArgumentlistExpression, visitClosureListExpression, visitBytecodeExpression, visitMethodCallExpression, visitStaticMethodCallExpression, visitConstructorCallExpression, visitTernaryExpression, visitFieldExpression, visitShortTernaryExpression, visitBinaryExpression, visitPrefixExpression, visitPostfixExpression, visitBooleanExpression, visitClosureExpression, visitTupleExpression, visitMapExpression, visitMapEntryExpression, visitRangeExpression, visitAttributeExpression, visitBitwiseNegationExpression, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class CodeVisitorSupport` | `visitClassExpression, visitPropertyExpression, visitConstantExpression, visitReturnStatement, visitListExpression, visitMethodPointerExpression, visitVariableExpression, visitDeclarationExpression, visitGStringExpression, visitArrayExpression, visitSpreadExpression, visitSpreadMapExpression, visitNotExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitCastExpression, visitArgumentlistExpression, visitClosureListExpression, visitBytecodeExpression, visitIfElse, visitBreakStatement, visitContinueStatement, visitThrowStatement, visitSynchronizedStatement, visitCatchStatement, visitMethodCallExpression, visitStaticMethodCallExpression, visitConstructorCallExpression, visitTernaryExpression, visitFieldExpression, visitShortTernaryExpression, visitBinaryExpression, visitPrefixExpression, visitPostfixExpression, visitBooleanExpression, visitClosureExpression, visitTupleExpression, visitMapExpression, visitMapEntryExpression, visitRangeExpression, visitAttributeExpression, visitBitwiseNegationExpression, visitForLoop, visitBlockStatement, visitWhileLoop, visitDoWhileLoop, visitExpressionStatement, visitAssertStatement, visitTryCatchFinally, visitSwitch, visitCaseStatement, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public def VariableScopeVisitor(SourceUnit source, boolean recurseInnerClasses)

    - #### public def VariableScopeVisitor(SourceUnit source)

    - #### protected SourceUnit getSourceUnit()

    - #### public void prepareVisit(ClassNode node)

      Setup the current class node context.

      Parameters:
        node

    - #### public void visitAnnotations(AnnotatedNode node)

    - #### @Override public void visitBinaryExpression(BinaryExpression be)

    - #### public void visitBlockStatement(BlockStatement block)

    - #### public void visitCatchStatement(CatchStatement statement)

    - #### public void visitClass(ClassNode node)

    - #### public void visitClosureExpression(ClosureExpression expression)

    - #### public void visitConstructorCallExpression(ConstructorCallExpression call)

    - #### protected void visitConstructorOrMethod(MethodNode node, boolean isConstructor)

    - #### public void visitDeclarationExpression(DeclarationExpression expression)

    - #### public void visitField(FieldNode node)

    - #### public void visitFieldExpression(FieldExpression expression)

    - #### public void visitForLoop(ForStatement forLoop)

    - #### public void visitIfElse(IfStatement ifElse)

    - #### public void visitMethodCallExpression(MethodCallExpression call)

    - #### public void visitProperty(PropertyNode node)

    - #### public void visitPropertyExpression(PropertyExpression expression)

    - #### public void visitVariableExpression(VariableExpression expression)